////////////////////////////////////////////////////////
// Game Server programming
// create by Kim Dong-sung
// Update 2009.01.11
////////////////////////////////////////////////////////

#include "Command_Proc.h"

CmdMap cmd_switch;

void cmd_trigger()
{
	cmd_switch.insert(make_pair("/user"		, CMD_USER));
	cmd_switch.insert(make_pair("/who"		, CMD_WHO));
	cmd_switch.insert(make_pair("/passwd"	, CMD_PASSWD));
	cmd_switch.insert(make_pair("/last"		, CMD_LAST));
	cmd_switch.insert(make_pair("/walk"		, CMD_WALK));
	cmd_switch.insert(make_pair("/run"		, CMD_RUN));
	cmd_switch.insert(make_pair("/stop"		, CMD_STOP));
	cmd_switch.insert(make_pair("/toward"	, CMD_TOWARD));
	cmd_switch.insert(make_pair("/tleft"	, CMD_TLEFT));
	cmd_switch.insert(make_pair("/tright"	, CMD_TRIGHT));

	CmdMap::iterator pos;
	for (pos = cmd_switch.begin(); pos != cmd_switch.end(); ++pos) {
		cout <<  pos->first.c_str() << ' ' << setw(10)
		<< " | " << pos->second << endl;
	}
	cout << endl;
}

// sql?
char* cmd_user(int id)
{
	char q[BUFSIZE] =  {'\0',};
	DB_log_write(id,"view user");

    sql_qur(id, "select ID from user;");				// query 
    sql_get_result(id, q);	 	// query  db   

	send_iocp(ClientData[id].socket_info, "=== this is all user list === \r\n");
	send_iocp(ClientData[id].socket_info, q);
	
	return q;
}

char* cmd_who(int id, char *arg1)
{
	int i;
	char q[BUFSIZE] =  {'\0',};
	// if cmd have login arg
	if(strlen(arg1))
	{
		int is_login = -1;
		for(i=CLIENT_START; i < client_count; ++i)
		{
			if(ClientData[i].situation > CMD_STOP)
			{
				if(strcmp(ClientData[i].id, arg1) == 0)
				{
				    is_login = i;	
				 	break;	
				}
			}
		}
		
		if(is_login != -1)
		{
			sprintf(q,"select Date_Time from log where ID = '%s' and log = 'login!';",
				ClientData[is_login].id);
			sql_qur(id, q);
			sql_get_last_result(id, q);
					
			sprintf(q, "%s login time : %s, now position(%f, %f)\n",
				ClientData[is_login].id, q,
				ClientData[is_login].pos_x, ClientData[is_login].pos_y);
		}
		else
		{
			char date[30];
			float x = 0.0f, y = 0.0f;
			int dir = 0;
			sprintf(q,"select Date_Time from log where ID = '%s' and action = 'log out';",
				arg1);
			sql_qur(id, q);
			sql_get_last_result(id, date);
			DB_user_load(id ,arg1, &x, &y, &dir);
			
			sprintf(q, "%s logout time : %s, position(%f, %f)\n",
				arg1, date, ClientData[id].pos_x, ClientData[id].pos_y);
		}	
		
	//	send_message(id, message);
	}
	// else
	else
	{
		// ۰  ʾ;;
	//	send_message(id, "this is connectting user list in now");
		for(i=CLIENT_START; i < client_count; ++i)
		{
			if(ClientData[i].situation > CMD_STOP)
			{
					sprintf(q,"%s\n%s %f %f %d\n", q,
					ClientData[i].id,
					ClientData[i].pos_x,
					ClientData[i].pos_y,
					ClientData[i].direction);
			}
		}
	}

	return q;
}

char* cmd_passwd(int id, char *arg1)
{
	char q[BUFSIZE];
	sprintf(q, "update user set password = '%s' where ID='%s';",
		arg1, ClientData[id].id);

	if(sql_qur(id, q) == 0)
	{
		DB_log_write(id,"change passwd");
		sprintf(q,"password change the %s\n", arg1);	
	}

	return q;
}

char* cmd_last(int id, char *arg1, int num)
{
	char q[BUFSIZE];

	if(strlen(arg1) && num)
	{
		sprintf(q, "select Date_Time, log from log where ID ='%s' order by Date_Time desc limit %d;", arg1, num);
		printf("last cmd!!\n\n");
		sql_qur(id, q);
		sql_get_result(id, q);
		sprintf(q,"%s last %d",arg1, num);
		DB_log_write(id,q);
	}

	return q;
}

char* cmd_walk(int id)
{
	ClientData[id].situation = CMD_WALK;
//	DB_log_write(id,"");
//	sprintf(q, "walk command\n");

	return "walk command\n";
}

char* cmd_run(int id)
{
	ClientData[id].situation = CMD_RUN;
//	DB_log_write(id,"");
//	sprintf(q, "run command\n");

	return "run command\n";
}

char* cmd_stop(int id)
{
	ClientData[id].situation = CMD_STOP;
//	DB_log_write(id,"");
//	sprintf(msg,"stop command\n");
	return "stop command\n";
}

char* cmd_toward(int id, int azimuth)
{
	char q[BUFSIZE];

	if(ClientData[id].situation == CMD_STOP)
	{
		ClientData[id].direction = azimuth;
//		DB_log_write(id,"toward");
		sprintf(q,"this is dircetion change %d\n", azimuth);
	}
	else
		sprintf(q,"I want to stop!!\n");

	return q;
}

char* cmd_tleft(int id, int angle)
{
	char q[BUFSIZE];

	if(ClientData[id].situation == CMD_STOP)
	{
		ClientData[id].direction += angle;
		ClientData[id].direction %= 360;
//		DB_log_write(id,"tern left");
		sprintf(q,"this is tern left %d\n", angle);
	}
	else
		sprintf(q,"I want to stop!!\n");

	return q;
}

char* cmd_tright(int id, int angle)
{
	char q[BUFSIZE];

	if(ClientData[id].situation == CMD_STOP)
	{
		ClientData[id].direction -= angle;
		ClientData[id].direction %= 360;
//		DB_log_write(id,"tern right");
		sprintf(q,"this is tern right %d\n", angle);
	}
	else
		sprintf(q,"I want to stop!!\n");

	return q;
}

void cmd_justic(char *command, int id)
{
	char cmd[20] = {'\0',}, arg1[20] = {'\0',}, arg2[20] = {'\0',};
	char msg[BUFSIZE];

	sscanf(command, "%s %s %s", cmd, arg1, arg2);
	printf("cmd = %s, arg1 = %s, arg2 = %s\n", cmd, arg1, arg2);

	//cmd Ʈ    map Ἥ 
	// Լ ͷ ڸ Ѱܹ.
	CmdMap::iterator pos;
	pos = cmd_switch.find(cmd);
	if (pos != cmd_switch.end()) 
	{
		switch(pos->second)
		{
			case CMD_USER:		strcpy(msg, cmd_user(id));						break;
			case CMD_WHO:		strcpy(msg, cmd_who(id, arg1));					break;
			case CMD_PASSWD:	strcpy(msg, cmd_passwd(id, arg1));				break;
			case CMD_LAST:		strcpy(msg, cmd_last(id, arg1, atoi(arg2)));	break;
			case CMD_WALK:		strcpy(msg, cmd_walk(id));						break;
			case CMD_RUN:		strcpy(msg, cmd_run(id));						break;
			case CMD_STOP:		strcpy(msg, cmd_stop(id));						break;
			case CMD_TOWARD:	strcpy(msg, cmd_toward(id, atoi(arg1)));		break;
			case CMD_TLEFT:		strcpy(msg, cmd_tleft(id, atoi(arg1)));			break;
			case CMD_TRIGHT:	strcpy(msg, cmd_tright(id, atoi(arg1)));		break;
		}
    }
	else
		sprintf(msg, "%s is not command\n",command);

	send_iocp(ClientData[id].socket_info, msg);
//	send(id, msg, (size_t)strlen(msg), 0);
}

int cmd_process(char *cmd, int id)
{
	if(cmd[0] == '/')
	{
		cmd_justic(cmd, id);
		return 0;
	}
	
	printf("%d chating msg : %s\n", id, cmd);		
	return 1;
}

