////////////////////////////////////////////////////////
// Game Server programming
// create by Kim Dong-sung
// Update 2009.01.11
////////////////////////////////////////////////////////

#include "MySql_Util.h"
#define SQL_TEST

MYSQL mysql;

// sql query
int sql_qur(int num, char *sql_query)
{
#ifdef SQL_TEST
	printf("input sql query is %s\n", sql_query);
#endif
	if( mysql_real_query(&mysql, sql_query, (unsigned long)strlen(sql_query)) )
	{
		printf("sql_qul() error : %s\n", sql_query);
		DB_error_log_write(num, "sql_qul() error"); 
	//	perror( mysql_error(&mysql) );
	//	exit( 1 );
		return -1;
	}
	return 0;
}

// print sql result
int sql_print_result(int num, char *result)
{
	MYSQL_RES *res;
	MYSQL_ROW row;
	MYSQL_FIELD *fld;
	int fields;

	if( !(res=mysql_store_result(&mysql)) )
	{
		printf("sql_print_result() error1 : %s\n", result);
		DB_error_log_write(num, "sql_print_result() error1"); 
		return -1;
	//	perror( mysql_error(&mysql) );
	//	exit( 1 );
	}
	
	sprintf(result, "");

	while( (row=mysql_fetch_row(res)) )
	{
		for(int i=0 ; i<mysql_num_fields(res) ; ++i)
		{
			fld = mysql_fetch_field_direct(res, i);

			if(i == 0)
				sprintf( result, "%s%20s: %s", result, fld->name, row[i]);
			else
				sprintf( result, "%s\n%20s: %s", result, fld->name, row[i]);

			if( !strlen(row[i]))
			{
				printf("sql_print_result() error2 : %s\n", result);
				DB_error_log_write(num, "sql_print_result() error2");
				return -1;
//				mysql_free_result(res);
//				mysql_close(&mysql);
//				exit(0);
			}
		}
		sprintf(result, "%s\n\n", result);
	}

	mysql_free_result(res);

	return 0;
}

int sql_get_result(int num, char *result)
{	
	MYSQL_RES *res;
	MYSQL_ROW row;
	int line = 0;
	
	if( !(res=mysql_store_result(&mysql)) )
	{
		printf("sql_get_result() error1 : %s\n", result);
		DB_error_log_write(num, "sql_get_result() error1");
//		perror( mysql_error(&mysql) );
//		exit( 1 );
		return -1;
	}
	
	sprintf(result, "");
	
	while((row=mysql_fetch_row(res)))
	{
		for(int i=0 ; i < mysql_num_fields(res) ; ++i)
		{
			if(i == 0 && line == 0)
				sprintf( result, "%s", row[i] );
			else
				sprintf( result, "%s\r\n%s", result, row[i] );
		
			if( !strlen(row[i]))
			{
				printf("sql_get_result() error2 : %s\n", result);
				DB_error_log_write(num, "sql_get_result() error2");
//				mysql_free_result(res);
//				mysql_close(&mysql);
//				exit(0);
				return -1;
			}
		}
		++line;
	}
	result[strlen(result)] = '\0';
	mysql_free_result(res);

	return 0;
}

int sql_get_last_result(int num, char *result)
{	
	MYSQL_RES *res;
	MYSQL_ROW row;
	int line = 0;
	
	if( !(res=mysql_store_result(&mysql)) )
	{
		printf("sql_get_last_result() error1 : %s\n", result);
		DB_error_log_write(num, "sql_get_last_result() error1");
//		perror( mysql_error(&mysql) );
//		exit( 1 );
		return -1;
	}
	
	sprintf(result, "");
	
	while( (row=mysql_fetch_row(res)) )
	{
		for(int i=0 ; i < mysql_num_fields(res) ; ++i)
		{
			sprintf( result, "%s", row[i] );
		
			if( !strlen(row[i]))
			{
				printf("sql_get_last_result() error2 : %s\n", result);
				DB_error_log_write(num, "sql_get_last_result() error2");
				return -1;
//				mysql_free_result(res);
//				mysql_close(&mysql);
//				exit(0);
			}
		}
		++line;
	}
	result[strlen(result)] = '\0';
	mysql_free_result(res);

	return 0;
}

void sql_init(char *host, char *user, char *password, char *db_name, int port)
{
	mysql_init( &mysql );

	if( !mysql_real_connect(&mysql,
				host,				    // host
				user,					// user
				password,				// passwd
				db_name,			    // db
				port,                   // port
				NULL,
				0) ) 
	{
		perror( mysql_error(&mysql) );
		printf("!\n");
		exit( 1 );
	}
	printf("My-Sql DB Ǿϴ.\n") ;
}

void sql_end()
{
	mysql_close(&mysql);
}

// converting string to float
float sql_string_to_float( const char *str )
{
	int i, flag;
	float result;
	result = (float)0.0;
	for ( i = 0, flag = 0; str[i]; ++i )
	{
		if ( str[i] == '.' ) { flag = 1; continue; }

		if ( flag ) flag *= 10;
		result *= (float)10.0;
		result += (str[i]-'0');
	}
	if ( flag ) result /= (float)flag;
	return result;
}

// base item load to db
void DB_user_load(int num, char *ID, float *pos_x, float *pos_y, int *dir)
{
	char query[256];
	char temp_id[20];
	char temp_pw[20];
//	char temp_px[20];
//	char temp_py[20];
//	char temp_dir[20];
	sprintf(query, "select * from user where ID='%s';", ID);
	sql_qur(num, query);
    sql_get_result(num, query);
  	
	sscanf(query, "%s\n%s\n%f\n%f\n%d",
	 temp_id, temp_pw, pos_x, pos_y, dir);
	
//	*pos_x = sql_string_to_float(temp_px);
//	*pos_y = sql_string_to_float(temp_py);
//	*dir = atoi(temp_dir);
}

void DB_data_write(int num)
{
	char q[BUFSIZE];
	sprintf(q, "update user set pos_x='%f', pos_y='%f', direction = '%d' where ID='%s';",
		ClientData[num].pos_x,
		ClientData[num].pos_y,
		ClientData[num].direction,
		ClientData[num].id);
	sql_qur(num, q);

#ifdef SQL_TEST
	printf("%s\n",q);	
#endif
}

void DB_log_write(int num, char *action)
{
	char q[BUFSIZE];
	char date_data[20];
	char act[20];
	
	time_get_system(date_data);
	
	if(strlen(action))
	{
		sprintf(q,"insert into log values('%s', '%s', '%s');",
					ClientData[num].id,
					date_data,
					action);
	}
	else
	{
		switch(ClientData[num].situation)
		{
			case LOGOUT:
				strcpy(act, "log out");
				break;
			case CMD_STOP:
				strcpy(act, "stop");
				break;
			case CMD_WALK:
				strcpy(act, "walk");
				break;
			case CMD_RUN:
				strcpy(act, "run");
				break;
		}
	
		sprintf(q,"insert into log values('%s', '%s', '%s');",
					ClientData[num].id,
					date_data,
					act);
	}	
	sql_qur(num, q);	
//	printf("%s\n",q);
}

void DB_error_log_write(int num, char *err)
{
	char q[BUFSIZE];
	char date_data[20];

	time_get_system(date_data);
	
	sprintf(q,"insert into error_log values('%s', '%s', '%s');",
				ClientData[num].id,
				err,
				date_data);
	
	sql_qur(num, q);	
//	printf("%s\n",q);
}
// select password from user where ID='admin'; ...
// modify
// update user set pos_x='10.3'where ID='test';
// modify test pos_x is 10.3 
