////////////////////////////////////////////////////////
// Game Server programming
// create by Kim Dong-sung
// Update 2009.01.11
////////////////////////////////////////////////////////

#include "server_util.h"
#include "Command_Proc.h"

#define SERVER_TEST

int count_time = 0;
float radius_view = 50;
float radius_listen = 100;

int accept_proc(SOCKET *listen_sock, HANDLE *hcp)
{
	// accept()
	SOCKADDR_IN clientaddr;
	int addrlen = sizeof(clientaddr);
	SOCKET client_sock = accept(*listen_sock, (SOCKADDR *)&clientaddr, &addrlen);
	if(client_sock == INVALID_SOCKET)
	{
		err_display("accept()");
		return -1;
	}
	printf("[TCP ] Ŭ̾Ʈ  : IP ּ = %s, Ʈ ȣ = %d \n",
		inet_ntoa(clientaddr.sin_addr),
		ntohs(clientaddr.sin_port));

	// ϰ  Ϸ Ʈ 
	HANDLE hResult = CreateIoCompletionPort((HANDLE)client_sock,
		*hcp, (DWORD)client_sock, 0);
	if(hResult == NULL)
	{
		err_quit("create iocp");
	}

	//   ü Ҵ
	SOCKETINFO *ptr = new SOCKETINFO;
	if(ptr == NULL)
	{
		err_quit("[] ޸ !!\n");
	}

	ZeroMemory(&(ptr->overlapped), sizeof(ptr->overlapped));
	ptr->sock = client_sock;
	ptr->wsabuf.buf = ptr->buf;
	ptr->wsabuf.len = BUFSIZE;

	ptr->info_num = Set_id_number();

	ClientData[ptr->info_num].situation = INPUT_ID;
	ClientData[ptr->info_num].socket_info = ptr;

	client_count = max_id_number();

	// 񵿱  
	recv_iocp(ptr);

	return 0;
}

void log_out_process(SOCKETINFO *ptr)
{
	// ̻ α׾ƿ̶ log   
	DB_data_write(ptr->info_num);

	ClientData[ptr->info_num].id[0] ='\0';
	ClientData[ptr->info_num].situation = LOGOUT;
	ClientData[ptr->info_num].socket_info = NULL;
	
	DB_log_write(ptr->info_num,"log out");
//	--client_count;
	client_count = max_id_number();

	closesocket(ptr->sock);
}

int is_log_out(DWORD *cbTransferred, SOCKET *client_sock, SOCKETINFO *ptr, SOCKADDR_IN *clientaddr, int retval)
{		
	// 񵿱   Ȯ
	if(retval == 0 || *cbTransferred == 0)
	{
		if(retval == 0)
		{
			DWORD temp1, temp2;
			WSAGetOverlappedResult(ptr->sock, &(ptr->overlapped),
				&temp1, FALSE, &temp2);
			err_display("WSAGetOverlappedResult()");
		}
		
		log_out_process(ptr);

		printf("[TCP ] Ŭ̾Ʈ  : IP ּ = %s, Ʈ ȣ = %d \n",
			inet_ntoa(clientaddr->sin_addr),
			ntohs(clientaddr->sin_port));

		delete ptr;		

		return 1;
	}

	return 0;
}

int send_iocp(SOCKETINFO *ptr, char *msg)
{
	int retval;
	ptr->wsabuf.buf = msg;
	ptr->wsabuf.len = (ULONG)strlen(msg);
	
	retval = WSASend(ptr->sock, 
					&(ptr->wsabuf), 
					1, 
					NULL, 
					0, 
					NULL, 
					NULL);

/*	if(retval == SOCKET_ERROR)
	{
		if(WSAGetLastError() != WSA_IO_PENDING)
		{
			err_display("WSASend()");
		}
	//	return -1;
	}
*/
	return 0;
}

int recv_iocp(SOCKETINFO *ptr)
{
	int retval;

	ZeroMemory(&(ptr->overlapped), sizeof(ptr->overlapped));
	ptr->wsabuf.buf = ptr->buf;
	ptr->wsabuf.len = BUFSIZE;

	DWORD 	flags=0;

	retval = WSARecv(ptr->sock, 
					&(ptr->wsabuf), 
					1, 
					NULL, 
					&flags, 
					&(ptr->overlapped), 
					NULL
					);

	if(retval == SOCKET_ERROR)
	{
		if(WSAGetLastError() != WSA_IO_PENDING)
		{
			err_display("WSARecv()");
		}
		return -1;
	}
	return 0;
}

// ä ھ
void chating_core(SOCKETINFO *ptr)
{
	// init accept client?	
	if(ClientData[ptr->info_num].situation < LOGIN)
	{
		login_authenticate(ptr);
		
		return ;
	}
	else
	{
		send_iocp(ptr, ptr->buf);
		int plist[MAX_NEIGHBORS] = {0,};
			
		// cmd_process  1̸ ֺ ޽ 
		// ƴϸ /  ۵Ǵ  ޽ ..
		if(cmd_process(ptr->buf, ptr->info_num))
		{
			char buf[BUFSIZE];
			int i;
			// server_util -> core insert!
			// all broadcasting
			ClientData[ptr->info_num].n_sum = 
				get_neighbors(ClientData[ptr->info_num].pos_x, 
						  ClientData[ptr->info_num].pos_y, 
						  radius_listen,
						  &plist[0]);
			
			sprintf(buf, "[%s] %s",
						ClientData[ptr->info_num].id,
						ptr->buf);
												
			for(i=CLIENT_START; i <= client_count; ++i)
			{
				int t = i - CLIENT_START;

				if(plist[t])
				{
					if(ptr->info_num != plist[t])
						send_iocp(ClientData[plist[t]].socket_info, buf);
						//send (plist[i], buf_in, (int)strlen(buf_in),0);
				}
				else
					break;
			}
		}
	}

}

// id ߺ üũ, ũ 0, ƴϸ ش Ϲȣ 
int check_id_unique(char *id)
{
	int i;
#ifdef SERVER_TEST
	printf("unique check %s\n",id);
#endif
	for(i=CLIENT_START; i < client_count; ++i)
	{
		if(ClientData[i].situation < LOGIN)
		{
#ifdef SERVER_TEST
			printf("%d compare %s, %s\n", i, ClientData[i].id, id);
#endif
			if(!strcmp(ClientData[i].id, id))
				return i;
		}	
	}
	return 0;
}

// login Ϸ id identity Ȯ
// gui client  id/password  ÿ ðŴ  ٽ ؾ .
void login_authenticate(SOCKETINFO *ptr)
{
	switch(ClientData[ptr->info_num].situation)
    {
    	// recv first word is id
    	case INPUT_ID:
    	{
			int sk = check_id_unique(ptr->buf);
			// check unique, id
			if(sk == 0)
			{
				// server unique id
				strncpy(ClientData[ptr->info_num].id, ptr->buf, 20);
#ifdef SERVER_TEST
				printf("check id %s\n", ClientData[ptr->info_num].id);
#endif
				ClientData[ptr->info_num].situation = INPUT_PW;
				send_iocp(ptr,"ID input ok");
			}
			else
			{
				// not unique id
				send_iocp(ptr, "using this id\n");

				log_out_process(ptr);				

				send_iocp(ClientData[sk].socket_info,
					"*caution* another computer conneting this id\n");
	        // 	send(sk, buf_in, (int)strlen(buf_in), 0);
            }
        }
        break;

		// recv second word is password
        case INPUT_PW:
		{
			char query[BUFSIZE] = { '\0' };
        	// make query 
            sprintf(query,
               "select password from user where ID='%s';",
			   ClientData[ptr->info_num].id);
            		
			sql_qur(ptr->info_num, query);				// quest query 
            sql_get_result(ptr->info_num, query);	 	// answer query
			
			// compare recv word, answer query
			if(!strcmp(ptr->buf, query))
            {
				char temp[BUFSIZE];
				float x = 0.0f, y =0.0f;
				int dir = 0;

#ifdef SERVER_TEST          		
				printf("[%d][%s] login success!\n",
					ptr->sock, ClientData[ptr->info_num].id );
#endif
				send_iocp(ptr, "Welcome game server, creater by 2003181006 Kim Dong-sung\n");

				DB_user_load(ptr->info_num, ClientData[ptr->info_num].id, &x, &y, &dir);
#ifdef SERVER_TEST
				printf("[%d][%s] dbload success!\n",
					ptr->sock, ClientData[ptr->info_num].id );
#endif
				add_point(ptr->info_num, x, y);
				ClientData[ptr->info_num].situation = CMD_STOP;
#ifdef SERVER_TEST
				printf("[%d][%s] world load success!\n",
					ptr->sock, ClientData[ptr->info_num].id  );
#endif
				ClientData[ptr->info_num].direction = dir;
				ClientData[ptr->info_num].event_time = getTickCount();   	
				ClientData[ptr->info_num].situation = CMD_STOP;

				DB_log_write(ptr->info_num,"login!");     	
   	        	
   	        	sprintf(temp, "your pos(%f, %f), direction %d\n",
					ClientData[ptr->info_num].pos_x,
					ClientData[ptr->info_num].pos_y,
					ClientData[ptr->info_num].direction);

				send_iocp(ptr, temp);

				//int plist[MAX_NEIGHBORS];
				//  ϴ    ִ ˷ִ Ʈ.. Լ .
				memset(ClientData[ptr->info_num].n_list,
					  (int)0x00,
					   MAX_NEIGHBORS);
				sprintf(temp, "\r\n  ͵ \r\n=================\r\n");
				printf("%s", temp);
				send_iocp(ptr, temp);
				
				ClientData[ptr->info_num].n_sum = 
					get_neighbors(ClientData[ptr->info_num].pos_x, 
							  ClientData[ptr->info_num].pos_y, 
							  radius_view,
							  &ClientData[ptr->info_num].n_list[0]);
				
				for(int i=CLIENT_START; i < ClientData[ptr->info_num].n_sum; ++i)
				{
					sprintf(temp,"ID : %s, pos[%d,%d]\r\n", 
							ClientData[ClientData[ptr->info_num].n_list[i]].id,
							ClientData[ClientData[ptr->info_num].n_list[i]].pos_x,
							ClientData[ClientData[ptr->info_num].n_list[i]].pos_y);
					send_iocp(ptr, temp);
					printf("%s", temp);
				}
			}
			else
			{
#ifdef SERVER_TEST
				printf("login fall\n");
#endif
				send_iocp(ptr, "password Ʋϴ");
				log_out_process(ptr);          
				return ;
			}
		}
		break;
	}
}

/////////////////////////////   ó κ /////////////////////////////
//  Ŭ̾Ʈ   ó 
void DRM_process()
{
	int i,j,sum;
	char send_buf[BUFSIZE] = {'\0'};
	float move = 0.0f;

	for(i=CLIENT_START; i <= client_count; ++i)
	{
		//   ó Ǿ.
		if(ClientData[i].situation > LOGIN)
		{
#ifdef SERVER_TEST
			printf("%d client situation the %d\n", i, ClientData[i].situation);
			printf("Now client_count is %d \n", client_count);
#endif
			switch(ClientData[i].situation)
			{
			case CMD_WALK:
			case CMD_RUN:
				if(ClientData[i].situation == CMD_WALK)
					 move = 1.0f;
				else
					 move = 10.0f;
					
				move_point(i, move);
				if(is_tickTime(&ClientData[i].event_time, 3))
				{
					ClientData[i].event_time = getTickCount();
				
					sprintf(send_buf, "My Position [x = %f, y = %f]\r\n",
								ClientData[i].pos_x,
								ClientData[i].pos_y);
							
					send_iocp(ClientData[i].socket_info, send_buf);
			//		send (i, send_buf, (int)strlen(send_buf), 0);
				}
				
				//     ġ  ƾ.. ƹ  ° 
				//  ̰  ϰ ϴ° ..
				//int plist[MAX_NEIGHBORS];
				memset(ClientData[i].n_list,
					  (int)0x00,
					   MAX_NEIGHBORS);
				sum = get_neighbors(ClientData[i].pos_x, 
									ClientData[i].pos_y, 
									radius_view,
									&ClientData[i].n_list[0]);

				//   ,   .	
				if(sum != ClientData[i].n_sum)
				{
					sprintf(send_buf, "ο  ֺ Ʈ\r\n\r\n");
					for(j=0; j<MAX_NEIGHBORS; ++j)
					{
						if(ClientData[i].n_list[j])
						{
							sprintf(send_buf, "%s\n[%s client] x = %f, y = %f\r\n",
								send_buf,
								ClientData[ClientData[i].n_list[j]].id,
								ClientData[ClientData[i].n_list[j]].pos_x,
								ClientData[ClientData[i].n_list[j]].pos_y);
								 					
						}
						else
							break;
					}
					ClientData[i].n_sum = sum;			
					send_iocp(ClientData[i].socket_info, send_buf);
				//	send (i, send_buf, (int)strlen(send_buf), 0);
				} 				

				break;
			}					
		}	
	}
}

//   ó (÷̾ ̵,  ̵ DRM )
DWORD WINAPI server_loop(LPVOID arg)
{
	int loop = 1;
	while(loop)
	{
		char send_buf[256];
		// 1 sec event process
		// server loop at 1 second
		if(is_tickTime(&server_time, 1))
		{
			time_get_system(send_buf);
			printf("[time] : %s", send_buf);
			if(count_time > 300)   // 1 sec * 300 = 5min
			{
				time_get_system(send_buf);
				printf("[DB Save Time] : %s\n",send_buf);
				count_time = 0;
				printf("Conneting client count is %d\n", client_count-CLIENT_START);

				for(int i=CLIENT_START; i < client_count; ++i)
				{
					if(ClientData[i].situation > LOGIN)
					{
						printf("number %d client time send\n", i);
						send_iocp(ClientData[i].socket_info, send_buf);
		//				send (i, send_buf, (int)strlen(send_buf), 0);
					}
				}
			}
			++count_time;

			server_time = getTickCount();	
			DRM_process();		
		}
	}

	return 0;
}

// Ŭ̾Ʈ   ְ ް ϴ ϴ 
DWORD WINAPI WorkerThread(LPVOID arg)
{
	HANDLE hcp = (HANDLE)arg;
	int retval;

	while(1)
	{
		// 񵿱  Ϸ ٸ
		DWORD cbTransferred;
		SOCKET client_sock;
		SOCKETINFO *ptr;
		retval = GetQueuedCompletionStatus(hcp, &cbTransferred,
			(LPDWORD)&client_sock, (LPOVERLAPPED*)&ptr, INFINITE);

		// Ŭ̾Ʈ  
		SOCKADDR_IN clientaddr;
		int addrlen = sizeof(clientaddr);
		getpeername(ptr->sock, (SOCKADDR*)&clientaddr, &addrlen);
	
		if(is_log_out(&cbTransferred, &client_sock, ptr, &clientaddr, retval) == 1)
			continue;

		//  ִ Ŭ̾Ʈ  ޽ ޴´
		recv_iocp(ptr);

		//  ͸ 
		ptr->buf[cbTransferred] = '\0';
		printf("[TCP/%s:%d]%s\n",
					inet_ntoa(clientaddr.sin_addr),
					ntohs(clientaddr.sin_port), ptr->buf);

		// ش ޽  ä ھ .
		chating_core(ptr);
	}

	return 0;
}