#include "Extern.h"
#include "Search_Neighbors.h"
#include "Logical_World.h"

// file open
void file_open()
{
	FILE *fp;
	int id;
	float x,y;
	char filename[255];
	//delete_list();
	printf("input filename : ");
	scanf("%s",filename);
	fp = fopen(filename,"r");
	fscanf(fp,"%f %f %f %f", &area_min.x, &area_min.y, &area_max.x, &area_max.y);
	initialize_fn(area_min.x, area_min.y, area_max.x, area_max.y);

	while(!feof(fp))
	{
		fscanf(fp,"%d %f %f", &id, &x, &y);
		add_point(id, x, y);
	}

	fclose(fp);
}

// input menu
int input_menu()
{
	int input = 0;

	printf("\n===============================\n");
	printf(" ** Find neighbors HomeWork **\n");
	printf("===============================\n");
	printf(" 0. Initialize\n");
	printf(" 1. Add Point\n");
	printf(" 2. Delete point\n");
	printf(" 3. Read point from file\n");
	printf(" 4. Get neighbors\n");
	printf(" 5. Performance test\n");
	printf(" 6. Quit\n");
	printf(" input meun number -> ");
	scanf("%d", &input);

	if(input < -1 || input > 6)
	{
		printf("error\n");
		return -1;
	}

	return input;
}

void printlist()
{
	for (int i=0; i<height_part_cnt; ++i) 
	{
		for(int j=0; j<width_part_cnt; ++j)
		{	
			printf("this coord (%d,%d) list \n", i, j);
			pt_list::iterator pl;
			for(pl = world_coord[j][i].begin();
				pl != world_coord[j][i].end();
				++pl)
			{				
				cout << " [ID : "<< pl->id << "|x : " << pl->x << ", y :" << pl->y << "] " << endl;
			}
		}
		cout << endl;
	}

	cout << "all print ok" << endl;
}

void main()
{
	//int radius = 30;
	int menu, loop = 1;
	int iInput;
	float fInput;
	point_t pInput;

	// menu loop
	while(loop)
	{
		if((menu = input_menu()) == -1)
		{
			printf("menu input error\n");
			continue;
		}

		switch(menu)
		{
		// init
		case 0:
			{
				if(input_Area(&area_min, &area_max) == -1)
					continue;

				initialize_fn(area_min.x, area_min.y, area_max.x, area_max.y);
			}
			break;

		// add point
		case 1:
			{
				printf("Input add ID : ");
				scanf("%d",&pInput.id);
				printf("Input x position : ");
				scanf("%f",&pInput.x);
				printf("Input y position : ");
				scanf("%f",&pInput.y);

				if(pInput.x > world_width || pInput.y > world_height)
				{
					printf("input error : over area value\n");
					continue;
				}

				add_point(pInput.id, pInput.x, pInput.y);
			}
			break;

		// delete point
		case 2:
			{
				printf("Input delete ID : ");
				scanf("%d",&iInput);

				del_point(iInput);
			}
			break;

		// open data file
		case 3:
			file_open();
			break;

		// find neighbors
		case 4:
			{
				neighbors_count = 0;
				printf("Input x position : ");
				scanf("%f",&pInput.x);
				printf("Input y position : ");
				scanf("%f",&pInput.y);
				printf("Input range : ");
				scanf("%f",&fInput);
				if(pInput.x > world_width || pInput.y > world_height)
				{
					printf("input error : over area value\n");
					continue;
				}

				get_neighbors(pInput.x, pInput.y, fInput, NULL, 0);
			}
			break;

		// print to all list points
		case 5:
			{
				printlist();
			}
			break;

		// exit
		case 6:
			printf("Bye~ \n");
			loop = 0;
			break;
		}
	}

	// memory free
	if(world_coord != NULL)
	{
		for(int i=0; i < width_part_cnt; ++i) 
			delete [] world_coord[i]; 

		delete []world_coord; 
	}
}
