#include <winsock2.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
using namespace std;

#define BUFSIZE 512

//   ϱ  ü
struct SOCKETINFO
{
	OVERLAPPED overlapped;
	SOCKET sock;
	char buf[BUFSIZE+1];
	WSABUF wsabuf;
};

//   Լ
DWORD WINAPI WorkerThread(LPVOID arg);

//  Լ
void err_quit(char *msg);
void err_display(char *msg);

int accept_proc(SOCKET *listen_sock, HANDLE *hcp)
{
	int retval;
	// accept()
	SOCKADDR_IN clientaddr;
	int addrlen = sizeof(clientaddr);
	SOCKET client_sock = accept(*listen_sock, (SOCKADDR *)&clientaddr, &addrlen);
	if(client_sock == INVALID_SOCKET)
	{
		err_display("accept()");
		return -1;
	}
	printf("[TCP ] Ŭ̾Ʈ  : IP ּ = %s, Ʈ ȣ = %d \n",
		inet_ntoa(clientaddr.sin_addr),
		ntohs(clientaddr.sin_port));

	// ϰ  Ϸ Ʈ 
	HANDLE hResult = CreateIoCompletionPort((HANDLE)client_sock,
		*hcp, (DWORD)client_sock, 0);
	if(hResult == NULL)
	{
		err_quit("create iocp");
	}

	//   ü Ҵ
	SOCKETINFO *ptr = new SOCKETINFO;
	if(ptr == NULL)
	{
		err_quit("[] ޸ !!\n");
	}
	ZeroMemory(&(ptr->overlapped), sizeof(ptr->overlapped));
	ptr->sock = client_sock;

	ptr->wsabuf.buf = ptr->buf;
	ptr->wsabuf.len = BUFSIZE;

	// 񵿱  
	DWORD recvbytes;
	DWORD flags = 0;
	retval = WSARecv(client_sock, &(ptr->wsabuf), 1, &recvbytes, &flags, &(ptr->overlapped), NULL);

	if(retval == SOCKET_ERROR)
	{
		if(WSAGetLastError() != ERROR_IO_PENDING)
		{
			err_display("WSARecv()");
		}
		return -1;
	}

	return 0;
}

int is_log_out(DWORD *cbTransferred, SOCKET *client_sock, SOCKETINFO *ptr, SOCKADDR_IN *clientaddr, int retval)
{		
	// 񵿱   Ȯ
	if(retval == 0 || *cbTransferred == 0)
	{
		if(retval == 0)
		{
			DWORD temp1, temp2;
			WSAGetOverlappedResult(ptr->sock, &(ptr->overlapped),
				&temp1, FALSE, &temp2);
			err_display("WSAGetOverlappedResult()");
		}
		closesocket(ptr->sock);
		printf("[TCP ] Ŭ̾Ʈ  : IP ּ = %s, Ʈ ȣ = %d \n",
			inet_ntoa(clientaddr->sin_addr),
			ntohs(clientaddr->sin_port));

		delete ptr;
		return 1;
	}

	return 0;
}

int send_iocp(SOCKETINFO *ptr, char *msg)
{
	int retval;
	ptr->wsabuf.buf = msg;
	ptr->wsabuf.len = strlen(msg);
	
	retval = WSASend(ptr->sock, 
					&(ptr->wsabuf), 
					1, 
					NULL, 
					0, 
					NULL, 
					NULL);

/*	if(retval == SOCKET_ERROR)
	{
		if(WSAGetLastError() != WSA_IO_PENDING)
		{
			err_display("WSASend()");
		}
	//	return -1;
	}
*/
	return 0;
}

int recv_iocp(SOCKETINFO *ptr)
{
	int retval;

	ZeroMemory(&(ptr->overlapped), sizeof(ptr->overlapped));
	ptr->wsabuf.buf = ptr->buf;
	ptr->wsabuf.len = BUFSIZE;

	DWORD 	flags=0;

	retval = WSARecv(ptr->sock, 
					&(ptr->wsabuf), 
					1, 
					NULL, 
					&flags, 
					&(ptr->overlapped), 
					NULL
					);

	if(retval == SOCKET_ERROR)
	{
		if(WSAGetLastError() != WSA_IO_PENDING)
		{
			err_display("WSARecv()");
		}
		return -1;
	}
	return 0;
}

int main()
{
	int retval;

	//  ʱȭ
	WSADATA wsa;
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		return -1;

	//  Ϸ Ʈ 
	HANDLE hcp = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0);
	if(hcp == NULL)
		return -1;

	// CPU  Ȯ
	SYSTEM_INFO si;
	GetSystemInfo(&si);

	// (CPU  * 2) ۾  
	HANDLE hThread;
	DWORD ThreadId;
	for(int i=0; i < (int)si.dwNumberOfProcessors*2; ++i)
	{
		hThread = CreateThread(NULL, 0, WorkerThread, hcp, 0, &ThreadId);
		if(hThread == NULL)
			return -1;
		CloseHandle(hThread);
	}

	// socket()
	SOCKET listen_sock = socket(AF_INET, SOCK_STREAM, 0);
	if(listen_sock == INVALID_SOCKET)
		err_quit("socket()");

	// bind()
	SOCKADDR_IN serveraddr;
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port = htons(9000);
	serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
	retval = bind(listen_sock, (SOCKADDR *)&serveraddr, sizeof(serveraddr));
	if(retval == SOCKET_ERROR)
		err_quit("bind()");

	// listen()
	retval = listen(listen_sock, SOMAXCONN);
	if(retval == SOCKET_ERROR)
		err_quit("listen()");

	while(1)
	{
		if(accept_proc(&listen_sock, &hcp) == -1)
			continue;
	}

	//  
	WSACleanup();
	return 0;
}

DWORD WINAPI WorkerThread(LPVOID arg)
{
	HANDLE hcp = (HANDLE)arg;
	int retval;

	while(1)
	{
		// 񵿱  Ϸ ٸ
		DWORD cbTransferred;
		SOCKET client_sock;
		SOCKETINFO *ptr;
		retval = GetQueuedCompletionStatus(hcp, &cbTransferred,
			(LPDWORD)&client_sock, (LPOVERLAPPED*)&ptr, INFINITE);

		// Ŭ̾Ʈ  
		SOCKADDR_IN clientaddr;
		int addrlen = sizeof(clientaddr);
		getpeername(ptr->sock, (SOCKADDR*)&clientaddr, &addrlen);
	
		if(is_log_out(&cbTransferred, &client_sock, ptr, &clientaddr, retval) == 1)
			continue;

		// 6. ޽! Ŭ̾Ʈ .
		if(send_iocp(ptr, "Test Message") == -1)
			continue;

		ptr->buf[cbTransferred] = '\0';
		if(send_iocp(ptr, ptr->buf) == -1)
			continue;
		
		// RECEIVE AGAIN
		if(recv_iocp(ptr) == -1)
			continue;

		ptr->buf[cbTransferred] = '\0';
		printf("[TCP/%s:%d]%s\n",
					inet_ntoa(clientaddr.sin_addr),
					ntohs(clientaddr.sin_port), ptr->buf);
	}
	
	return 0;
}

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(-1);
}

//  Լ  
void err_display(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

/*
#include <stdio.h>
#include <stdlib.h>
#include <process.h>                  // _beginthreadex()
#include <winsock2.h>

#include <iostream>

using namespace std;

#define BUFSIZE (1024 * 20)

typedef struct //  üȭ.
{
	SOCKET         hClntSock;             //  Ŭ̾Ʈ 
	SOCKADDR_IN clntAddr;         // Ŭ̾Ʈ  ּ
} PER_HANDLE_DATA, *LPPER_HANDLE_DATA;

typedef struct //    üȭ.
{
	OVERLAPPED overlapped;
	char buffer[BUFSIZE];
	WSABUF wsaBuf;
} PER_IO_DATA, *LPPER_IO_DATA;

DWORD WINAPI CompletionThread(LPVOID CompletionPortIO);
void ErrorHandling(char *message);

int main(int argc, char** argv)
{
	WSADATA wsaData;
	HANDLE hCompletionPort;       
	SYSTEM_INFO SystemInfo;
	SOCKADDR_IN servAddr;
	LPPER_IO_DATA PerIoData;
	LPPER_HANDLE_DATA PerHandleData;

	SOCKET hServSock;
	DWORD RecvBytes;
	int i;
	DWORD Flags;

	if(WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) // Load Winsock 2.2 DLL 
		ErrorHandling("WSAStartup() error!"); 

	DWORD dwProcessor;

	GetSystemInfo(&SystemInfo);

	dwProcessor = SystemInfo.dwNumberOfProcessors;

	// 1. Completion Port .
	hCompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, (dwProcessor * 2));

	// 2. Completion Port   ϷḦ  ϴ 带 CPU  ŭ .
	for(i=0; i < (dwProcessor * 2) + 2; ++i) 
	{
		CreateThread(NULL, 0, CompletionThread, (LPVOID)hCompletionPort, 0, NULL);
		// _beginthreadex(NULL, 0, CompletionThread, (LPVOID)hCompletionPort, 0, NULL);
		cout << "ũ " << endl;
	}

	hServSock = WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED);
	servAddr.sin_family=AF_INET;
	servAddr.sin_addr.s_addr=htonl(INADDR_ANY);
	servAddr.sin_port=htons(9000);

	if(bind(hServSock, (SOCKADDR*)&servAddr, sizeof(servAddr)) == SOCKET_ERROR)
	{
		cout << "  ε  !" << " : " << WSAGetLastError() << endl;
		exit(-1);
	}

	cout << "  ε" << endl;

	if(listen(hServSock, 5) == SOCKET_ERROR) {
		cout << "   !" << " : " << WSAGetLastError() << endl;
		exit(-1);
	}

	cout << " " << endl;

	while(TRUE)
	{              
		SOCKET hClntSock;
		SOCKADDR_IN clntAddr;         
		int addrLen=sizeof(clntAddr);

		hClntSock=accept(hServSock, (SOCKADDR*)&clntAddr, &addrLen);        

		//   Ŭ̾Ʈ  ڵ  ּ  .
		PerHandleData= new PER_HANDLE_DATA;//(LPPER_HANDLE_DATA)malloc(sizeof(PER_HANDLE_DATA));           
		PerHandleData->hClntSock=hClntSock;
		memcpy(&(PerHandleData->clntAddr), &clntAddr, addrLen);

		cout << "Ŭ̾Ʈ ӵ" << endl;

		// 3. Overlapped ϰ CompletionPort .
		CreateIoCompletionPort((HANDLE)hClntSock,
			hCompletionPort, 
			(DWORD)PerHandleData, 
			0);

		//   Ŭ̾Ʈ  ۸  ϰ 
		// OVERLAPPED ü  ʱȭ.
		PerIoData = new PER_IO_DATA; //(LPPER_IO_DATA)malloc(sizeof(PER_IO_DATA));
		memset(&(PerIoData->overlapped), 0, sizeof(OVERLAPPED));            
		PerIoData->wsaBuf.len = BUFSIZE;
		PerIoData->wsaBuf.buf = PerIoData->buffer;
		Flags=0;

		// 4. ø  Է.
		WSARecv(PerHandleData->hClntSock,     //  Է .
			&(PerIoData->wsaBuf),  //  Է  .
			1,                     //  Է  .
			&RecvBytes,                                  
			&Flags, 
			&(PerIoData->overlapped), // OVERLAPPED ü .
			NULL
			);                     
	}
	return 0;
}

// I/O Ϸῡ   ൿ  
DWORD WINAPI CompletionThread(LPVOID pComPort)
{
	HANDLE hCompletionPort =(HANDLE)pComPort;
	DWORD BytesTransferred;

	LPPER_HANDLE_DATA      PerHandleData;
	LPPER_IO_DATA          PerIoData;

	DWORD flags;

	while(1)
	{
		// 5.  Ϸ    . 
		GetQueuedCompletionStatus(hCompletionPort,
			&BytesTransferred,
			(LPDWORD)&PerHandleData,
			(LPOVERLAPPED*)&PerIoData,
			INFINITE);

		if(BytesTransferred == 0) //  ̸...
		{
			cout << "Ŭ̾Ʈ   Ͽϴ." << endl;

			closesocket(PerHandleData->hClntSock);
			delete PerHandleData;	//free(PerHandleData);
			delete PerIoData;		//free(PerIoData);
			continue;              
		}              

		// 6. ޽! Ŭ̾Ʈ .
		PerIoData->wsaBuf.len = BytesTransferred;
		WSASend(PerHandleData->hClntSock, 
			&(PerIoData->wsaBuf), 
			1, 
			NULL, 
			0, 
			NULL, 
			NULL);

		// RECEIVE AGAIN
		memset(&(PerIoData->overlapped), 0, sizeof(OVERLAPPED));
		PerIoData->wsaBuf.len=BUFSIZE;
		PerIoData->wsaBuf.buf=PerIoData->buffer;

		flags=0;
		WSARecv(PerHandleData->hClntSock, 
			&(PerIoData->wsaBuf), 
			1, 
			NULL, 
			&flags, 
			&(PerIoData->overlapped), 
			NULL
			);                                                   
	}
	return 0;
}

void ErrorHandling(char *message)
{
	fputs(message, stderr);
	fputc('\n', stderr);
	exit(1);
}
*/